/*********************************************************MITTELWERTE**************************************************/
/* 	Programm zur Mittelwertbildung an den Messpunkten eines Profilquerschnittes durch die Aufnahme mit einem 3 D ADV 
	Eingabe: Untransformierte Geschwindigkeitsdateien der Messpunkte, Format: Zeit y- z-Koordinate u- v- w-Komponente
	Ausgabeformat: y- z-Koordinate Mittelwert der u- v- w-Komponente						*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*	Hauptprogramm mit Argumenten aus dem Projekt ADDV	*/

main(int argc, char *argv[]){

	
	FILE *eingabe,*ausgabe;
	char pfad[255],datum[15],ypfad[255], zypfad[255], lamellenordner[5], lamellenpkt[5], mittelwertdatei[255], mpdatei[255], mpzeile[100];
	double t, y, z, vx, vy, vz, summe_vx, summe_vy, summe_vz, vx_mittel, vy_mittel, vz_mittel, anzahl;
	int i,j,k,l,n=9,m=25,weiter, ja;

	
	sprintf(pfad,"%s",argv[1]);			/* Einlesen des Ordners */
	strcpy(mittelwertdatei,pfad);
	strcat(mittelwertdatei,"/Punktmittel.gem");
	
	ausgabe=fopen(mittelwertdatei,"w");				/* Anlegen der neuen Datei */
	
	for(i=0;i<=m;i++){						/* Schleife fuer 1. Lamellenwert (Vorkommastelle) */
		for(j=0;j<=n;j++){					/* Schleife fuer 2. Lamellenwert (Erste Nachkommastelle) */
		for(k=0;k<=n;k++){					/* Schleife fuer 3. Lamellenwert (Zweite Nachkommastelle) */
		
			strcpy(ypfad,pfad);				/* Kopieren und Ueberschreiben des ypfad mit pfad */
			sprintf(lamellenordner,"/%i_%i%i",i,j,k);
			strcat(ypfad,lamellenordner);			/* Lamellenordner an Pfad anhaengen */
			
			for(l=1;l<=m;l++){				/* Schleife fuer Lamellenpunkt */ 
			
				strcpy(zypfad,ypfad);			/* Kopieren bzw. Ueberschreiben des zypfad mit ypfad */
				sprintf(lamellenpkt,"/%i",l);
				strcat(zypfad,lamellenpkt);		/* Messpunkt an Pfad anhaengen */
				
				strcpy(mpdatei,zypfad);			/* Anhaengen der Endungen fuer vel- und ctl-Dateien */
				strcat(mpdatei,".mp");
			
				eingabe=fopen(mpdatei,"r");		/* Oeffnen der Datei */
				
				if(eingabe!=NULL){
					
					summe_vx=0;
					summe_vy=0;
					summe_vz=0;
					anzahl=0;
					
					weiter=feof(eingabe);
					while(weiter==0){        /* Auslesen der *.mp-Zeilen, Aufsummieren der v-Werte und Zaehlen */
						
						fgets(mpzeile,100,eingabe);
						weiter=feof(eingabe);
						sscanf(mpzeile,"%lf%lf%lf%lf%lf%lf",&t,&y,&z,&vx,&vy,&vz);
						if(weiter==0){
							summe_vx+=vx;		//Summenbildung
							summe_vy+=vy;
							summe_vz+=vz;
							anzahl++;		//Zaehlen der Messwerte
						}
					}
					vx_mittel=summe_vx/anzahl;	/* Bildung der Punktmittelwerte */
					vy_mittel=summe_vy/anzahl;
					vz_mittel=summe_vz/anzahl;
					
		fprintf(ausgabe,"%lf\t%lf\t%lf\t%lf\t%lf\n",y,z,vx_mittel,vy_mittel,vz_mittel);
					
					fclose(eingabe);
				}
			}
		}
		}
	}
	fclose(ausgabe);
}
